       .OR $2000
       .TA $2000
*--------------------------------
* ZERO PAGE EQUATES
*--------------------------------
RANGE        .EQ $3E      & $3F, RANGE IN US
BUF.ADR      .EQ $80      &$81 BUF EL ADR
BUF1.ADR     .EQ $82      &$83 BUF1 EL ADR
BUF2.ADR     .EQ $84      &$85 BUF2 EL ADR
BUF.BAS.ADR  .EQ $86      &$87 BUF BASE ADR
BUF1.BAS.ADR .EQ $88      &$89 BUF1 BAS ADR
BUF2.BAS.ADR .EQ $8A      &$8B BUF2 BAS ADR
BECANG       .EQ $8C      &8D ROOM BEACON ANGLE
NDREDS       .EQ $8E      NO.OF DOOR EDGES DETECTED
NELMNT       .EQ $8F      & $90 NO.OF ELEMENTS IN A BUF
DESTAT       .EQ $91      DOOR EDGE STATUS FLAG
CNTLO        .EQ $92
CNTMD        .EQ $93
CNTHI        .EQ $94
AVGLO        .EQ $95
AVGMD        .EQ $96
AVGHI        .EQ $97
RMCODE       .EQ $98
QCL          .EQ $99
QCM          .EQ $9A
QCH          .EQ $9B
TCL          .EQ $9C
TCM          .EQ $9D
TCH          .EQ $9E
FLG          .EQ $9F
FLH          .EQ $A0
RCL          .EQ $A1
RCM          .EQ $A2
RCH          .EQ $A3
TMP          .EQ $A4
CNT          .EQ $A5
ACX          .EQ $A6
ACL          .EQ $A7
ACM          .EQ $A8
ACH          .EQ $A9
SCL          .EQ $AA
SCM          .EQ $AB
SCH          .EQ $AC
TEMP         .EQ $ED      & $EE&$EF TEMP STORAGE
SS           .EQ $F0      RNGBUF EL PTR
*                         LO,HI BYTE
THSHLD       .EQ $F2      DOUBLET SEARCH THRESHOLD
INDEX        .EQ $F3      & $F4 USED AS TEMP STORAGE
*                         IN 'GET.BUF.ADR'
NDBLET       .EQ $F5      NO.OF DOUBLETS FOUND
DOORS        .EQ $F6      NO.OF DOORS FOUND
COUNT        .EQ $F7
HDINIT       .EQ $F8      HEAD INIT STATUS (0 - NOT, 1 - YES)
MSPSTP       .EQ $F9      MS PER STEP
DEGRS        .EQ $FA      & $FB NO.OF DEGRS TO MOVE
*                          (L0,HI) IN 'NDEGRS'
STEPNO       .EQ $FC 
DIREC        .EQ $FD
PRTIM0       .EQ $FE
PRTIM1       .EQ $FF
*--------------------------------
* ABSOLUTE EQUATES
*--------------------------------
CNTRAL .EQ $C052
CNTRBL .EQ $C053
CRAINT .EQ $C054    
CRBINT .EQ $C055
CNTRAH .EQ $C056
CNTRBH .EQ $C057
IPORT0 .EQ $C070
IPORT1 .EQ $C071
OPORT0 .EQ $C078
OPORT1 .EQ $C079
PAUSE  .EQ $FB78
CLRDSP .EQ $F928
PRNTAX .EQ $F196
HEXOUT .EQ $F160
LCDOUT .EQ $FDED
SPOUT  .EQ $FB99
PRCIN  .EQ $F3DB
CROUT  .EQ $FD8E
PRCOUT .EQ $F3CE
*--------------------------------
* NUMERIC EQUATES
*--------------------------------
CW     .EQ $00      CLOCKWISE HEAD ROTATION
CCW    .EQ $01      COUNTER CLOCKWISE HEAD ROTATION
LFTSTP .EQ $04      LEFT STOP BIT MASK (BIT5)
RGTSTP .EQ $02      RIGHT STOP BIT
HEDCTR .EQ $B4      HEAD CENTER 180 DEGRS FROM
*                    LEFT STOP
SECPST .EQ $0A      SECS PER STEP = 10 MS
XMTRON .EQ $40      RADIO XMTR ON BIT
XMTROF .EQ $BF      RADIO XMTR OFF BIT
VSWON  .EQ $10      HEAD SONAR ON BIT
VSWOF  .EQ $EF      HEAD SONAR OFF BIT
BECBIT .EQ $80      BEACON DETECT BIT MASK
DORBIT .EQ $40      DOOR EDGE DETECT BIT MASK
RNGBUF .EQ $2000    RANGE BUFFER BASE ADDRESS
DF1BUF .EQ $2400    FIRST RANGE DIFFERENCE BUFFER BASE ADR
DF2BUF .EQ $2800    SECOND RANGE DIFFERENCE BUFFER BASE ADR
DUBBUF .EQ $2C00    DOUBLET BUFFER BASE ADR
DORBUF .EQ $2D00    DOOR BUFFER BASE ADR
DEBUF  .EQ $2E00    DOOR EDGE BUFFER BASE ADR
NRBELS .EQ $0150    NO.OF RANGE BUFFER ELEMENTS=351
*
VAR    .BS 256      MATH PACK VARIABLES
*
       .LIST OFF
*
       .IN SRC.MATH.PACK
*
*      .LIST ON
*
ALPHA  .BS 2
BETA   .BS 2
GAMMA  .BS 2
RM     .BS 2
AMB    .BS 2
ABSAMB .BS 2
D      .BS 2
ABFLG  .BS 1
DIRFLG .BS 1
TRNFLG .BS 1
CHGCODE .BS 1
CMDBUF .BS 7
*
*
*--------------------------------
* SUBROUTINE GET.BUF.ADR
*
* ROUTINE TO CALCULATE THE ADDRESS OF A 16 BIT ELEMENT
* IN THE 'NRBELS' (2 BYTES) LONG BUFFER 'RNGBUF'
*
* ON ENTRY: 16 BIT SUBSCRIPT IN 'SS' AND 'SS'+1 (L,H)
* AND RANGE BUFFER ADDRESS IS IN 'BUF.BAS.ADR' (L) AND
* 'BUF.BAS.ADR'+1 (H)
*
* ON EXIT: ADDRESS OF ELEMENT IS IN 'BUF.ADR' (L)
* AND 'BUF.ADR'+1 (H)
*--------------------------------
GET.BUF.ADR
       LDA SS       GET SUBSCRIPT, MULT BY 2 AND SAVE
       ASL
       STA INDEX    AND SAVE IN INDEX
       LDA SS+1
       ROL
       STA INDEX+1
       CLC          ADD INDEX TO BASE ADR
       LDA BUF.BAS.ADR
       ADC INDEX
       STA BUF.ADR
       LDA BUF.BAS.ADR+1
       ADC INDEX+1
       STA BUF.ADR+1
       RTS
*--------------------------------
* SUBROUTINE GIVE.PROCON.CMD
*--------------------------------
GIVE.PROCON.CMD
       LDX #0
.1     LDA CMDBUF,X
       PHX
       JSR LCDOUT
*      JSR PRCOUT
       PLX
       INX
       CPX #7
       BNE .1
       JSR CROUT
       RTS
*--------------------------------
* SUBROUTINE WAIT.ONE.SEC
*--------------------------------
WAIT.ONE.SEC
       LDA #4
.1     LDY #250
       JSR PAUSE
       DEC
       BNE .1
       RTS
*--------------------------------
* SUBROUTINE HOOK.UP
*--------------------------------
HOOK.UP
       JSR START.ENGINES
       LDX #0
       LDA #'0
       STA CMDBUF,X
       INX
       LDA #'8
.1     STA CMDBUF,X
       INX
       JSR GET.MOTOR.DIST
.15    JSR GIVE.PROCON.CMD
       JSR PRCIN
       CMP #'0
       BNE .2
       JSR ENBBMP
       LDX #1
       LDA #'6
       STA CMDBUF,X
       BRA .15
.2     CMP #'4
       BNE .3
       JSR GET.RESPONSE
       BNE .4
.25    LDA #$80
       STA $C078
       RTS
.3     CMP #'3
       BEQ .5
       CMP #'5
       BEQ .6
       BRA .7
.4     LDX #2
       LDA #'0
       STA CMDBUF,X
       INX
       LDA #'1
       STA CMDBUF,X
       INX
       LDA #'0
       STA CMDBUF,X
       INX
       STA CMDBUF,X
       JSR GIVE.PROCON.CMD
       JSR GET.RESPONSE
       BNE .55
       BRA .25
.5     JSR GET.RESPONSE
       BEQ .25
.55    LDX #0
       LDA #'2
       STA CMDBUF,X
       JSR GIVE.PROCON.CMD
       JSR GET.RESPONSE
       BNE .65
       BRA .25
.6     JSR GET.RESPONSE
       BEQ .25
.65    LDX #0
       LDA #'3
       STA CMDBUF,X
       JSR GIVE.PROCON.CMD
       JSR GET.RESPONSE
       BNE .7
       BRA .25
.7     LDX #0
.8     LDA MSG,X
       BEQ .9
       JSR LCDOUT
       INX
       BRA .8
.9     RTS
MSG    .AS /GAVE UP/
       .HS 00
*--------------------------------
* JSR GET.RESPONSE
*--------------------------------
GET.RESPONSE
       JSR PRCIN
       JSR LCDOUT
       JSR WAIT.ONE.SEC
       LDA $C070
       AND #$01
       RTS
*--------------------------------
* CMDBUF
*--------------------------------
*--------------------------------
* SUBROUTINE GOTO.CHARGER
*
* ROUTINE TO PUT PRO ON CHARGE
*--------------------------------
GOTO.CHARGER
       JSR GET.ROOM.PS
       LDA RMCODE   GET ROOM BEACON CODE
       CMP CHGCODE  CK IF CHARGER BEACON
       BEQ CG1      BR IF SO
       SEC          FLG IF WRONG ROOM
       RTS
CG1    LDA BECANG
       STA ALPHA
       LDA BECANG+1
       STA ALPHA+1
       JSR FIND.RMB      GET RM AND BETA
       LDA #1       SET ABFLG TO 1
       STA ABFLG
       SEC          CALC ALPHA-BETA
       LDA ALPHA     AND GET ABS(ALPHA-BETA)
       SBC BETA
       STA AMB
       STA ABSAMB
       LDA ALPHA+1
       SBC BETA+1
       STA AMB+1
       STA ABSAMB+1
       BPL CG2      BR IF (ALPHA-BETA) IS POS
       SEC          ELSE CHG SGN
       LDA #0
       SBC AMB
       STA ABSAMB
       LDA #0
       SBC AMB+1
       STA ABSAMB+1
       DEC ABFLG    SET ABFLG TO $FF
       DEC ABFLG
CG2    LDA #90      CK IF ABS(ALPHA-BETA)<90
       CMP ABSAMB
       LDA #0
       SBC ABSAMB+1
       BCS CG4      BR IF SO
       LDA ABFLG    ELSE, CK ABFLG
       BMI CG3      BR IF $FF
       CLC          ELSE ADD 360 TO BETA
       LDA #360
       ADC BETA
       STA BETA
       LDA /360
       ADC BETA+1
       STA BETA+1
       LDA #$FF     FIX ABFLG
       STA ABFLG
       BRA CG4      GO ON
CG3    CLC          ADD 360 TO ALPHA
       LDA #360
       ADC ALPHA
       STA ALPHA
       LDA /360
       ADC ALPHA+1
       STA ALPHA+1
       LDA #$01     FIX ABFLG
       STA ABFLG
CG4    LDA #180     CK IF BETA>180
       CMP BETA
       LDA #0
       SBC BETA+1
       BCS CG6      BR IF NO
       SEC          GET GAMMA=BETA-270
       LDA BETA
       SBC #270
       STA GAMMA
       LDA BETA+1
       SBC /270
       STA GAMMA+1
       STZ ACL      GET TAN(BETA-ALPHA)
       SEC
       LDA BETA
       SBC ALPHA
       STA ACM
       LDA BETA+1
       SBC ALPHA+1
       STA ACH
       JSR TAN
       STZ RCL      GET D=RM*TAN(BETA-ALPHA)
       LDA RM
       STA RCM
       LDA RM+1
       STA RCH
       JSR MUL
       JSR SGN      GET SGN(D)
       BNE .1
       INC
.1     STA DIRFLG   SAVE IN DIRECTION FLAG
       BPL CG5      BR IF POS
       JSR CHG      ELSE CHANGE SIGN OF D
CG5    JSR SET.TRNFLG
       LDA ACM
       STA D
       LDA ACH
       STA D+1
       BRA CG8
CG6    SEC          GET GAMMA=BETA-90
       LDA BETA
       SBC #90
       STA GAMMA
       LDA BETA+1
       SBC #0
       STA GAMMA+1
       STZ ACL      GET TAN(ALPHA-BETA)
       SEC
       LDA ALPHA
       SBC BETA
       STA ACM
       LDA ALPHA+1
       SBC BETA+1
       STA ACH
       JSR TAN
       STZ RCL      GET D=RM*TAN(ALPHA-BETA)
       LDA RM
       STA RCM
       LDA RM+1
       STA RCH
       JSR MUL
       JSR SGN      GET SGN(D)
       BNE .1
       INC
.1     STA DIRFLG   SAVE
       BPL CG7      BR IF POS
       JSR CHG      ELSE CHG SGN
CG7    JSR SET.TRNFLG
       LDA ACM
       STA D
       LDA ACH
       STA D+1
*
* TURN GAMMA DEGREES
*
CG8    LDX #0
       LDA GAMMA+1  GET DIR TO TURN
       BMI CG9      IF NEG TURN LEFT
       LDA #'2      ELSE TURN RIGHT
       BRA CG10
CG9    SEC
       LDA #0
       SBC GAMMA
       STA GAMMA
       LDA #0
       SBC GAMMA+1
       STA GAMMA+1
       LDA #'3
CG10   STA CMDBUF,X
       INX
       LDA #'8      SPD=8
       STA CMDBUF,X
       JSR START.ENGINES
       LDY GAMMA    SET REST OF CMDBUF
       LDA GAMMA+1
       LDX #0
       JSR COMPLETE.AND.GIVE.CMD
*
* TRANSLATE D
*
       LDX #0
       LDA DIRFLG   GET DIR TO MOVE
       BMI CG11     IF NEG MOVE BACK
       LDA #'0      ELSE MOVE FWD
       BRA CG12
CG11   LDA #'1
CG12   STA CMDBUF,X
       LDY D        SET REST OF CMDBUF (LEAVE SPD=8)
       LDA D+1
       LDX #1
       JSR COMPLETE.AND.GIVE.CMD
*
* TURN 90 DEGREES
*
       LDX #0
       LDA TRNFLG
       BMI CG13
       LDA #'2
       BRA CG14
CG13   LDA #'3
CG14   STA CMDBUF,X
       LDY #90
       LDA #0
       LDX #0
       JSR COMPLETE.AND.GIVE.CMD
       JSR CENTER.HEAD
*      JSR HOOK.UP
       CLC
       RTS
*--------------------------------
* SUBROUTINE FIND.RMBETA
*
* ROUTINE TO FIND RM AND BETA
* 
* ON ENTRY: (1) RNGBUF IS LOADED
*           (2) DF1BUF IS LOADED
*           (3) BECANG IS KNOWN
* ON EXIT:  (1) RM IS COMPUTED
*           (2) BETA IS COMPUTED
*--------------------------------
FIND.RMBETA
       LDA #DF1BUF  PT TO 1ST DIFF BUF
       STA BUF.BAS.ADR
       LDA /DF1BUF
       STA BUF.BAS.ADR+1
       LDA BECANG   SET SS TO BECANG
       STA SS
       LDA BECANG+1
       STA SS+1
       JSR GETELH   GET EL HIBY
       BMI STPFWD   BR IF NEG
       BNE STPBAC   BR IF POS
       DEC BUF.ADR  MAY BE ZERO, CK LOBY-HINB
       BPL .1
       DEC BUF.ADR+1
.1     LDA (BUF.ADR)
       AND #$F0
       BNE STPBAC   BR IF NOT ZERO
       LDX #10      DIFF IS ZERO, BACK UP 10 DEGREES
.2     JSR DECSS
       DEX
       BNE .2
       BRA STPFWD
STPBAC JSR DECSS    STEP BACK ONE STEP
SB0    LDA SS       SET SS TO BETA
       STA BETA
       LDA SS+1
       STA BETA+1
       JSR GETELH
       BMI SB1      BR IF NEG
       BRA STPBAC   ELSE KEEP CKING
SB1    STZ TEMP     GOT SGN CHG
SB2    JSR DECSS    BACK ONE STEP
       JSR GETELH
       BPL SB0
       INC TEMP
       LDA TEMP     CK IF GOT 5 CONSECUTIVE NEGS
       CMP #5
       BNE SB2      BR IF NO
       BRA FINUP
STPFWD JSR INCSS    FWD ONE STEP
SF0    LDA SS       SET SS TO BETA
       STA BETA
       LDA SS+1
       STA BETA+1
       JSR GETELH
       BPL SF1
       BRA STPFWD
SF1    STZ TEMP     GOT SGN CHG
SF2    JSR INCSS    FWD ONE STEP
       JSR GETELH
       BMI SF0
       INC TEMP
       LDA TEMP
       CMP #5       CK IF GOT 5 CONSECUTIVE POSS
       BNE SF2      BR IF NO
FINUP  LDA #RNGBUF  GET RM
       STA BUF.BAS.ADR
       LDA /RNGBUF
       STA BUF.BAS.ADR+1
       LDA BETA
       STA SS
       LDA BETA+1
       STA SS+1
       JSR GET.BUF.ADR
       LDA (BUF.ADR)
       STA RM
       INC BUF.ADR
       BNE .1
       INC BUF.ADR+1
.1     LDA (BUF.ADR)
       STA RM+1
       RTS
*--------------------------------
* SUBROUTINE DECSS
*
* ROUTINE TO DEC SS AND PROVIDE WRAP AROUND
*--------------------------------
DECSS  DEC SS
       BPL .1
       DEC SS+1
.1     LDA SS+1
       BPL .2
       LDA #360
       STA SS
       LDA /360
       STA SS+1
.2     RTS
*--------------------------------
* SUBROUTINE INCSS
*
* ROUTINE TO INC SS AND PROVIDE WRAP AROUND
*--------------------------------
INCSS  INC SS
       BNE .1
       INC SS+1
.1     LDA SS
       CMP #360+1
       BNE .2
       LDA SS+1
       CMP /360
       BNE .2
       STZ SS
       STZ SS+1
.2     RTS
*--------------------------------
* SUBROUTINE GETELH
*
* ROUTINE TO GET HIBY OF EL FROM A BUFFER
*--------------------------------
GETELH JSR GET.BUF.ADR
       INC BUF.ADR
       BNE .1
       INC BUF.ADR+1
.1     LDA (BUF.ADR)
       RTS
*--------------------------------
* SUBROUTINE SET.TRNFLG
*--------------------------------
SET.TRNFLG
       LDA ABFLG
       CMP DIRFLG
       BNE .1
       LDA #$FF
       BRA .2
.1     LDA #$01
.2     STA TRNFLG
       RTS
*--------------------------------
* SUBROUTINE COMPLETE.AND.GIVE.CMD
*--------------------------------
COMPLETE.AND.GIVE.CMD
       STZ ACL    LOAD MATH AC WITH CMD  
       STY ACM
       STA ACH
       TXA          CK IF ANGLE OR DIST
       BNE .1       BR IF DIST
       LDA #$00     LOAD MATCH RC WITH ANGLE CONV FAC
       STA RCL
       LDA #$08
       STA RCM
       LDA #$00
       STA RCH
       BRA .2
.1     LDA #$C0     LOAD MATH RC WITH DIST CONV FAC
       STA RCL
       LDA #$0F
       STA RCM
       LDA #$01
       STA RCH
.2     JSR DIV
       LDA ACM
       JSR BN2ASC
       LDX #2
       STA CMDBUF,X
       INX
       TYA
       STA CMDBUF,X
       INX
       PHX
       LDA ACL
       JSR BN2ASC
       PLX
       STA CMDBUF,X
       INX
       TYA
       STA CMDBUF,X
       INX
       LDA #'0
       STA CMDBUF,X
       JSR GIVE.PROCON.CMD
       RTS
*--------------------------------
START.ENGINES
       LDA #$01
       STA $C078
*      LDY #100
*      JSR PAUSE
*      JSR PRCIN
       JSR LCDOUT
ENBBMP LDA #'6
       JSR LCDOUT
*      JSR PRCOUT
       LDA #'0
       JSR LCDOUT
*      JSR PRCOUT
*      JSR PRCIN
       JSR LCDOUT
       JSR CROUT
       RTS
*--------------------------------
* SUBROUTINE GET.MOTOR.DIST
*--------------------------------
GET.MOTOR.DIST
       STZ AVGLO
       STZ AVGLO+1
       STZ AVGLO+2
       LDA #8
.1     PHA
       JSR RANGER
       CLC
       LDA RANGE
       ADC AVGLO
       STA AVGLO
       LDA RANGE+1
       ADC AVGLO+1
       STA AVGLO+1
       LDA #0
       ADC AVGLO+2
       STA AVGLO+2
       LDY #100
       JSR PAUSE
       PLA
       DEC
       BNE .1
       LDX #3
.2     CLC
       ROR AVGLO+2
       ROR AVGLO+1
       ROR AVGLO
       DEX
       BNE .2
       STZ ACL
       LDA AVGLO
       STA ACM
       LDA AVGLO+1
       STA ACH
       LDX #3
.3     CLC
       ROR AVGLO+2
       ROR AVGLO+1
       ROR AVGLO
       DEX
       BNE .3
       STZ RCL
       CLC
       LDA #$05
       ADC AVGLO
       STA RCM
       LDA #$08
       ADC AVGLO+1
       STA RCH
       JSR SUB
       LDA #$C0     DIV BY 271.75
       STA RCL
       LDA #$0F
       STA RCM
       LDA #$01
       STA RCH
       JSR DIV
       LDA ACM
       JSR BN2ASC
       LDX #2
       STA CMDBUF,X
       INX
       TYA
       STA CMDBUF,X
       INX
       PHX
       LDA ACL
       JSR BN2ASC
       PLX
       STA CMDBUF,X
       INX
       TYA
       STA CMDBUF,X
       INX
       LDA #'0
       STA CMDBUF,X
       RTS
*--------------------------------
GET.ROOM.PARMS
       RTS
*--------------------------------
CENTER.HEAD
       RTS
*--------------------------------
RANGER
       RTS
*--------------------------------
BN2ASC TAX
       AND #$F0
       LSR
       LSR
       LSR
       LSR
       JSR NASCII
       PHA
       TXA
       AND #$0F
       JSR NASCII
       TAY
       PLA
       RTS
*--------------------------------
NASCII CMP #10
       BCC NAS1
       CLC
       ADC #7
NAS1   ADC #'0
       RTS
*--------------------------------
GET.ROOM.PS
       STZ RMCODE
       LDA #90     
       STA BECANG
       LDA #0
       STA BECANG+1
       RTS
*--------------------------------
FIND.RMB
       LDA #$FF
       STA RM
       LDA #$20
       STA RM+1
       LDA #120
       STA BETA
       LDA #0
       STA BETA+1
       RTS
       .LIST OFF
